diff --git a/rsvg-size-callback.c b/rsvg-size-callback.c
new file mode 100644
index 0000000..d8a114f
--- /dev/null
+++ b/rsvg-size-callback.c
@@ -0,0 +1,103 @@
+/*
+   Copyright (C) 2000 Eazel, Inc.
+   Copyright (C) 2002 Dom Lachowicz <cinamod@hotmail.com>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with this program; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.
+
+   Author: Raph Levien <raph@artofcode.com>
+*/
+
+#include "config.h"
+
+#include "rsvg-size-callback.h"
+
+#include <math.h>
+
+void
+_rsvg_size_callback (int *width, int *height, gpointer data)
+{
+    struct RsvgSizeCallbackData *real_data = (struct RsvgSizeCallbackData *) data;
+    double zoomx, zoomy, zoom;
+
+    int in_width, in_height;
+
+    in_width = *width;
+    in_height = *height;
+
+    switch (real_data->type) {
+    case RSVG_SIZE_ZOOM:
+        if (*width < 0 || *height < 0)
+            return;
+
+        *width = floor (real_data->x_zoom * *width + 0.5);
+        *height = floor (real_data->y_zoom * *height + 0.5);
+        break;
+
+    case RSVG_SIZE_ZOOM_MAX:
+        if (*width < 0 || *height < 0)
+            return;
+
+        *width = floor (real_data->x_zoom * *width + 0.5);
+        *height = floor (real_data->y_zoom * *height + 0.5);
+
+        if (*width > real_data->width || *height > real_data->height) {
+            zoomx = (double) real_data->width / *width;
+            zoomy = (double) real_data->height / *height;
+            zoom = MIN (zoomx, zoomy);
+
+            *width = floor (zoom * *width + 0.5);
+            *height = floor (zoom * *height + 0.5);
+        }
+        break;
+
+    case RSVG_SIZE_WH_MAX:
+        if (*width < 0 || *height < 0)
+            return;
+
+        zoomx = (double) real_data->width / *width;
+        zoomy = (double) real_data->height / *height;
+        if (zoomx < 0)
+            zoom = zoomy;
+        else if (zoomy < 0)
+            zoom = zoomx;
+        else
+            zoom = MIN (zoomx, zoomy);
+
+        *width = floor (zoom * *width + 0.5);
+        *height = floor (zoom * *height + 0.5);
+        break;
+
+    case RSVG_SIZE_WH:
+        if (real_data->width != -1)
+            *width = real_data->width;
+        if (real_data->height != -1)
+            *height = real_data->height;
+        break;
+
+    default:
+        g_assert_not_reached ();
+    }
+
+    if (real_data->keep_aspect_ratio) {
+        int out_min = MIN (*width, *height);
+
+        if (out_min == *width) {
+            *height = in_height * ((double) *width / (double) in_width);
+        } else {
+            *width = in_width * ((double) *height / (double) in_height);
+        }
+    }
+}
diff --git a/rsvg-size-callback.h b/rsvg-size-callback.h
new file mode 100644
index 0000000..70507d0
--- /dev/null
+++ b/rsvg-size-callback.h
@@ -0,0 +1,52 @@
+/*
+   Copyright (C) 2000 Eazel, Inc.
+   Copyright (C) 2002 Dom Lachowicz <cinamod@hotmail.com>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with this program; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.
+
+   Author: Raph Levien <raph@artofcode.com>
+*/
+
+#ifndef RSVG_SIZE_CALLBACK_H
+#define RSVG_SIZE_CALLBACK_H
+
+#include <glib.h>
+
+G_BEGIN_DECLS
+
+typedef enum {
+    RSVG_SIZE_ZOOM,
+    RSVG_SIZE_WH,
+    RSVG_SIZE_WH_MAX,
+    RSVG_SIZE_ZOOM_MAX
+} RsvgSizeType;
+
+struct RsvgSizeCallbackData {
+    RsvgSizeType type;
+    double x_zoom;
+    double y_zoom;
+    gint width;
+    gint height;
+
+    gboolean keep_aspect_ratio;
+};
+
+G_GNUC_INTERNAL
+void _rsvg_size_callback (int *width, int *height, gpointer data);
+
+G_END_DECLS
+
+#endif /* RSVG_SIZE_CALLBACK_H */
diff --git a/rsvg-structure.c b/rsvg-structure.c
index 4841494..4ab4473 100644
--- a/rsvg-structure.c
+++ b/rsvg-structure.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-structure.c: Rsvg's structual elements
 
@@ -50,25 +51,8 @@ rsvg_node_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
     if (!state->visible)
         return;
 
-    if (g_slist_find(ctx->ptrs, self) != NULL)
-    {
-        /*
-         * 5.3.1 of the SVG 1.1 spec (http://www.w3.org/TR/SVG11/struct.html#HeadOverview)
-         * seems to indicate ("URI references that directly or indirectly reference
-         * themselves are treated as invalid circular references") that circular
-         * references are invalid, and so we can drop them to avoid infinite recursion.
-         * 
-         * See also http://bugzilla.gnome.org/show_bug.cgi?id=518640
-         */
-        g_warning("Circular SVG reference noticed, dropping");
-        return;
-    }
-    ctx->ptrs = g_slist_append(ctx->ptrs, self);
-
     self->draw (self, ctx, dominate);
     ctx->drawsub_stack = stacksave;
-
-    ctx->ptrs = g_slist_remove(ctx->ptrs, self);
 }
 
 /* generic function for drawing all of the children of a particular node */
@@ -102,16 +86,17 @@ _rsvg_node_dont_set_atts (RsvgNode * node, RsvgHandle * ctx, RsvgPropertyBag * a
 }
 
 void
-_rsvg_node_init (RsvgNode * self)
+_rsvg_node_init (RsvgNode * self,
+                 RsvgNodeType type)
 {
-	self->parent = NULL;
+    self->type = type;
+    self->parent = NULL;
     self->children = g_ptr_array_new ();
     self->state = g_new (RsvgState, 1);
     rsvg_state_init (self->state);
     self->free = _rsvg_node_free;
     self->draw = _rsvg_node_draw_nothing;
     self->set_atts = _rsvg_node_dont_set_atts;
-    self->type = NULL;
 }
 
 void
@@ -123,9 +108,6 @@ _rsvg_node_finalize (RsvgNode * self)
     }
     if (self->children != NULL)
         g_ptr_array_free (self->children, TRUE);
-    if (self->type != NULL)
-        g_string_free (self->type, TRUE);
-
 }
 
 void
@@ -157,7 +139,7 @@ rsvg_new_group (void)
 {
     RsvgNodeGroup *group;
     group = g_new (RsvgNodeGroup, 1);
-    _rsvg_node_init (&group->super);
+    _rsvg_node_init (&group->super, RSVG_NODE_TYPE_GROUP);
     group->super.draw = _rsvg_node_draw_children;
     group->super.set_atts = rsvg_node_group_set_atts;
     return &group->super;
@@ -166,8 +148,8 @@ rsvg_new_group (void)
 void
 rsvg_pop_def_group (RsvgHandle * ctx)
 {
-    if (ctx->priv->currentnode != NULL)
-        ctx->priv->currentnode = ctx->priv->currentnode->parent;
+    g_assert (ctx->priv->currentnode != NULL);
+    ctx->priv->currentnode = ctx->priv->currentnode->parent;
 }
 
 void
@@ -200,7 +182,7 @@ rsvg_node_use_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
     RsvgNodeUse *use = (RsvgNodeUse *) self;
     RsvgNode *child;
     RsvgState *state;
-    double affine[6];
+    cairo_matrix_t affine;
     double x, y, w, h;
     x = _rsvg_css_normalize_length (&use->x, ctx, 'h');
     y = _rsvg_css_normalize_length (&use->y, ctx, 'v');
@@ -209,18 +191,20 @@ rsvg_node_use_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 
     rsvg_state_reinherit_top (ctx, self->state, dominate);
 
-    child = use->link;
-
-    /* If it can find nothing to draw... draw nothing */
+    if (use->link == NULL)
+      return;
+    child = rsvg_acquire_node (ctx, use->link);
     if (!child)
         return;
-    else if (rsvg_node_is_ancestor (child, self))       /* or, if we're <use>'ing ourself */
+    else if (rsvg_node_is_ancestor (child, self)) {     /* or, if we're <use>'ing ourself */
+        rsvg_release_node (ctx, child);
         return;
+    }
 
-    state = rsvg_state_current (ctx);
-    if (strcmp (child->type->str, "symbol")) {
-        _rsvg_affine_translate (affine, x, y);
-        _rsvg_affine_multiply (state->affine, affine, state->affine);
+    state = rsvg_current_state (ctx);
+    if (RSVG_NODE_TYPE (child) != RSVG_NODE_TYPE_SYMBOL) {
+        cairo_matrix_init_translate (&affine, x, y);
+        cairo_matrix_multiply (&state->affine, &affine, &state->affine);
 
         rsvg_push_discrete_layer (ctx);
         rsvg_state_push (ctx);
@@ -232,23 +216,27 @@ rsvg_node_use_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 
         if (symbol->vbox.active) {
             rsvg_preserve_aspect_ratio
-                (symbol->preserve_aspect_ratio, symbol->vbox.w, symbol->vbox.h, &w, &h, &x, &y);
+                (symbol->preserve_aspect_ratio,
+                 symbol->vbox.rect.width, symbol->vbox.rect.height,
+                 &w, &h, &x, &y);
+
+            cairo_matrix_init_translate (&affine, x, y);
+            cairo_matrix_multiply (&state->affine, &affine, &state->affine);
 
-            _rsvg_affine_translate (affine, x, y);
-            _rsvg_affine_multiply (state->affine, affine, state->affine);
-            _rsvg_affine_scale (affine, w / symbol->vbox.w, h / symbol->vbox.h);
-            _rsvg_affine_multiply (state->affine, affine, state->affine);
-            _rsvg_affine_translate (affine, -symbol->vbox.x, -symbol->vbox.y);
-            _rsvg_affine_multiply (state->affine, affine, state->affine);
+            cairo_matrix_init_scale (&affine, w / symbol->vbox.rect.width, h / symbol->vbox.rect.height);
+            cairo_matrix_multiply (&state->affine, &affine, &state->affine);
 
-            _rsvg_push_view_box (ctx, symbol->vbox.w, symbol->vbox.h);
+            cairo_matrix_init_translate (&affine, -symbol->vbox.rect.x, -symbol->vbox.rect.y);
+            cairo_matrix_multiply (&state->affine, &affine, &state->affine);
+
+            _rsvg_push_view_box (ctx, symbol->vbox.rect.width, symbol->vbox.rect.height);
             rsvg_push_discrete_layer (ctx);
             if (!state->overflow || (!state->has_overflow && child->state->overflow))
-                rsvg_add_clipping_rect (ctx, symbol->vbox.x, symbol->vbox.y,
-                                        symbol->vbox.w, symbol->vbox.h);
+                rsvg_add_clipping_rect (ctx, symbol->vbox.rect.x, symbol->vbox.rect.y,
+                                        symbol->vbox.rect.width, symbol->vbox.rect.height);
         } else {
-            _rsvg_affine_translate (affine, x, y);
-            _rsvg_affine_multiply (state->affine, affine, state->affine);
+            cairo_matrix_init_translate (&affine, x, y);
+            cairo_matrix_multiply (&state->affine, &affine, &state->affine);
             rsvg_push_discrete_layer (ctx);
         }
 
@@ -260,6 +248,7 @@ rsvg_node_use_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
             _rsvg_pop_view_box (ctx);
     }
 
+    rsvg_release_node (ctx, child);
 }
 
 static void
@@ -267,7 +256,7 @@ rsvg_node_svg_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 {
     RsvgNodeSvg *sself;
     RsvgState *state;
-    gdouble affine[6], affine_old[6], affine_new[6];
+    cairo_matrix_t affine, affine_old, affine_new;
     guint i;
     double nx, ny, nw, nh;
     sself = (RsvgNodeSvg *) self;
@@ -279,46 +268,40 @@ rsvg_node_svg_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 
     rsvg_state_reinherit_top (ctx, self->state, dominate);
 
-    state = rsvg_state_current (ctx);
+    state = rsvg_current_state (ctx);
 
-    for (i = 0; i < 6; i++)
-        affine_old[i] = state->affine[i];
+    affine_old = state->affine;
 
     if (sself->vbox.active) {
         double x = nx, y = ny, w = nw, h = nh;
         rsvg_preserve_aspect_ratio (sself->preserve_aspect_ratio,
-                                    sself->vbox.w, sself->vbox.h, &w, &h, &x, &y);
-        affine[0] = w / sself->vbox.w;
-        affine[1] = 0;
-        affine[2] = 0;
-        affine[3] = h / sself->vbox.h;
-        affine[4] = x - sself->vbox.x * w / sself->vbox.w;
-        affine[5] = y - sself->vbox.y * h / sself->vbox.h;
-        _rsvg_affine_multiply (state->affine, affine, state->affine);
-        _rsvg_push_view_box (ctx, sself->vbox.w, sself->vbox.h);
+                                    sself->vbox.rect.width, sself->vbox.rect.height,
+                                    &w, &h, &x, &y);
+        cairo_matrix_init (&affine,
+                           w / sself->vbox.rect.width,
+                           0,
+                           0,
+                           h / sself->vbox.rect.height,
+                           x - sself->vbox.rect.x * w / sself->vbox.rect.width,
+                           y - sself->vbox.rect.y * h / sself->vbox.rect.height);
+        cairo_matrix_multiply (&state->affine, &affine, &state->affine);
+        _rsvg_push_view_box (ctx, sself->vbox.rect.width, sself->vbox.rect.height);
     } else {
-        affine[0] = 1;
-        affine[1] = 0;
-        affine[2] = 0;
-        affine[3] = 1;
-        affine[4] = nx;
-        affine[5] = ny;
-        _rsvg_affine_multiply (state->affine, affine, state->affine);
+        cairo_matrix_init_translate (&affine, nx, ny);
+        cairo_matrix_multiply (&state->affine, &affine, &state->affine);
         _rsvg_push_view_box (ctx, nw, nh);
     }
-    for (i = 0; i < 6; i++)
-        affine_new[i] = state->affine[i];
+
+    affine_new = state->affine;
 
     rsvg_push_discrete_layer (ctx);
 
     /* Bounding box addition must be AFTER the discrete layer push, 
        which must be AFTER the transformation happens. */
     if (!state->overflow && self->parent) {
-        for (i = 0; i < 6; i++)
-            state->affine[i] = affine_old[i];
+        state->affine = affine_old;
         rsvg_add_clipping_rect (ctx, nx, ny, nw, nh);
-        for (i = 0; i < 6; i++)
-            state->affine[i] = affine_new[i];
+        state->affine = affine_new;
     }
 
     for (i = 0; i < self->children->len; i++) {
@@ -334,7 +317,7 @@ rsvg_node_svg_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 static void
 rsvg_node_svg_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * atts)
 {
-    const char *id = NULL, *klazz = NULL, *value;
+    const char *value;
     RsvgNodeSvg *svg = (RsvgNodeSvg *) self;
 
     if (rsvg_property_bag_size (atts)) {
@@ -345,32 +328,51 @@ rsvg_node_svg_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * att
             svg->preserve_aspect_ratio = rsvg_css_parse_aspect_ratio (value);
         if ((value = rsvg_property_bag_lookup (atts, "width")))
             svg->w = _rsvg_css_parse_length (value);
-	else {
-	    svg->w.length = -1;
-	    svg->w.factor = '\0';
-	}
         if ((value = rsvg_property_bag_lookup (atts, "height")))
             svg->h = _rsvg_css_parse_length (value);
-	else {
-	    svg->h.length = -1;
-	    svg->h.factor = '\0';
-	}
-		/* 
-		 * x & y attributes have no effect on outermost svg
-		 * http://www.w3.org/TR/SVG/struct.html#SVGElement 
-		 */
+        /* 
+         * x & y attributes have no effect on outermost svg
+         * http://www.w3.org/TR/SVG/struct.html#SVGElement 
+         */
         if (self->parent && (value = rsvg_property_bag_lookup (atts, "x")))
             svg->x = _rsvg_css_parse_length (value);
         if (self->parent && (value = rsvg_property_bag_lookup (atts, "y")))
             svg->y = _rsvg_css_parse_length (value);
-        if ((value = rsvg_property_bag_lookup (atts, "class")))
-            klazz = value;
         if ((value = rsvg_property_bag_lookup (atts, "id"))) {
-            id = value;
             rsvg_defs_register_name (ctx->priv->defs, value, &svg->super);
         }
-        rsvg_parse_style_attrs (ctx, self->state, "svg", klazz, id, atts);
+        /*
+         * style element is not loaded yet here, so we need to store those attribues
+         * to be applied later.
+         */
+        svg->atts = rsvg_property_bag_dup(atts);
+    }
+}
+
+void
+_rsvg_node_svg_apply_atts (RsvgNodeSvg * self, RsvgHandle * ctx)
+{
+    const char *id = NULL, *klazz = NULL, *value;
+    if (self->atts && rsvg_property_bag_size (self->atts)) {
+        if ((value = rsvg_property_bag_lookup (self->atts, "class")))
+            klazz = value;
+        if ((value = rsvg_property_bag_lookup (self->atts, "id")))
+            id = value;
+        rsvg_parse_style_attrs (ctx, ((RsvgNode *)self)->state, "svg", klazz, id, self->atts);
+    }
+}
+
+static void
+_rsvg_svg_free (RsvgNode * self)
+{
+    RsvgNodeSvg *svg = (RsvgNodeSvg *) self;
+
+    if (svg->atts) {
+        rsvg_property_bag_free (svg->atts);
+        svg->atts = NULL;
     }
+
+    _rsvg_node_free (self);
 }
 
 RsvgNode *
@@ -378,7 +380,7 @@ rsvg_new_svg (void)
 {
     RsvgNodeSvg *svg;
     svg = g_new (RsvgNodeSvg, 1);
-    _rsvg_node_init (&svg->super);
+    _rsvg_node_init (&svg->super, RSVG_NODE_TYPE_SVG);
     svg->vbox.active = FALSE;
     svg->preserve_aspect_ratio = RSVG_ASPECT_RATIO_XMID_YMID;
     svg->x = _rsvg_css_parse_length ("0");
@@ -386,11 +388,21 @@ rsvg_new_svg (void)
     svg->w = _rsvg_css_parse_length ("100%");
     svg->h = _rsvg_css_parse_length ("100%");
     svg->super.draw = rsvg_node_svg_draw;
+    svg->super.free = _rsvg_svg_free;
     svg->super.set_atts = rsvg_node_svg_set_atts;
+    svg->atts = NULL;
     return &svg->super;
 }
 
 static void
+rsvg_node_use_free (RsvgNode * node)
+{
+    RsvgNodeUse *use = (RsvgNodeUse *) node;
+    g_free (use->link);
+    _rsvg_node_free (node);
+}
+
+static void
 rsvg_node_use_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * atts)
 {
     const char *value = NULL, *klazz = NULL, *id = NULL;
@@ -412,20 +424,23 @@ rsvg_node_use_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * att
             id = value;
             rsvg_defs_register_name (ctx->priv->defs, value, &use->super);
         }
-        if ((value = rsvg_property_bag_lookup (atts, "xlink:href")))
-            rsvg_defs_add_resolver (ctx->priv->defs, &use->link, value);
+        if ((value = rsvg_property_bag_lookup (atts, "xlink:href"))) {
+            g_free (use->link);
+            use->link = g_strdup (value);
+        }
         rsvg_parse_style_attrs (ctx, self->state, "use", klazz, id, atts);
     }
 
 }
 
 RsvgNode *
-rsvg_new_use ()
+rsvg_new_use (void)
 {
     RsvgNodeUse *use;
     use = g_new (RsvgNodeUse, 1);
-    _rsvg_node_init (&use->super);
+    _rsvg_node_init (&use->super, RSVG_NODE_TYPE_USE);
     use->super.draw = rsvg_node_use_draw;
+    use->super.free = rsvg_node_use_free;
     use->super.set_atts = rsvg_node_use_set_atts;
     use->x = _rsvg_css_parse_length ("0");
     use->y = _rsvg_css_parse_length ("0");
@@ -465,7 +480,7 @@ rsvg_new_symbol (void)
 {
     RsvgNodeSymbol *symbol;
     symbol = g_new (RsvgNodeSymbol, 1);
-    _rsvg_node_init (&symbol->super);
+    _rsvg_node_init (&symbol->super, RSVG_NODE_TYPE_SYMBOL);
     symbol->vbox.active = FALSE;
     symbol->preserve_aspect_ratio = RSVG_ASPECT_RATIO_XMID_YMID;
     symbol->super.draw = _rsvg_node_draw_nothing;
@@ -474,11 +489,11 @@ rsvg_new_symbol (void)
 }
 
 RsvgNode *
-rsvg_new_defs ()
+rsvg_new_defs (void)
 {
     RsvgNodeGroup *group;
     group = g_new (RsvgNodeGroup, 1);
-    _rsvg_node_init (&group->super);
+    _rsvg_node_init (&group->super, RSVG_NODE_TYPE_DEFS);
     group->super.draw = _rsvg_node_draw_nothing;
     group->super.set_atts = rsvg_node_group_set_atts;
     return &group->super;
@@ -513,7 +528,7 @@ rsvg_new_switch (void)
 {
     RsvgNodeGroup *group;
     group = g_new (RsvgNodeGroup, 1);
-    _rsvg_node_init (&group->super);
+    _rsvg_node_init (&group->super, RSVG_NODE_TYPE_SWITCH);
     group->super.draw = _rsvg_node_switch_draw;
     group->super.set_atts = rsvg_node_group_set_atts;
     return &group->super;
diff --git a/rsvg-structure.h b/rsvg-structure.h
index ac372e0..601a273 100644
--- a/rsvg-structure.h
+++ b/rsvg-structure.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-structure.h: Rsvg's structual elements
 
@@ -35,11 +36,17 @@
 
 G_BEGIN_DECLS 
 
-RsvgNode * rsvg_new_use (void);
+G_GNUC_INTERNAL
+RsvgNode *rsvg_new_use (void);
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_symbol (void);
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_svg (void);
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_defs (void);
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_group (void);
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_switch (void);
 
 typedef struct _RsvgNodeGroup RsvgNodeGroup;
@@ -49,6 +56,7 @@ typedef struct _RsvgNodeSvg RsvgNodeSvg;
 
 struct _RsvgNodeGroup {
     RsvgNode super;
+    char *name;
 };
 
 struct _RsvgNodeSymbol {
@@ -59,7 +67,7 @@ struct _RsvgNodeSymbol {
 
 struct _RsvgNodeUse {
     RsvgNode super;
-    RsvgNode *link;
+    char *link;
     RsvgLength x, y, w, h;
 };
 
@@ -68,17 +76,25 @@ struct _RsvgNodeSvg {
     gint preserve_aspect_ratio;
     RsvgLength x, y, w, h;
     RsvgViewBox vbox;
-    GdkPixbuf *img;
+    RsvgPropertyBag *atts;
 };
 
-void rsvg_pop_def_group		(RsvgHandle * ctx);
-void rsvg_node_group_pack	(RsvgNode * self, RsvgNode * child);
-
-void rsvg_node_draw		(RsvgNode * self, RsvgDrawingCtx * ctx, int dominate);
-void _rsvg_node_draw_children	(RsvgNode * self, RsvgDrawingCtx * ctx, int dominate);
-void _rsvg_node_finalize	(RsvgNode * self);
-void _rsvg_node_free		(RsvgNode * self);
-void _rsvg_node_init		(RsvgNode * self);
+G_GNUC_INTERNAL
+void rsvg_pop_def_group     (RsvgHandle * ctx);
+G_GNUC_INTERNAL
+void rsvg_node_group_pack   (RsvgNode * self, RsvgNode * child);
+G_GNUC_INTERNAL
+void rsvg_node_draw         (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate);
+G_GNUC_INTERNAL
+void _rsvg_node_draw_children   (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate);
+G_GNUC_INTERNAL
+void _rsvg_node_finalize    (RsvgNode * self);
+G_GNUC_INTERNAL
+void _rsvg_node_free        (RsvgNode * self);
+G_GNUC_INTERNAL
+void _rsvg_node_init        (RsvgNode * self, RsvgNodeType type);
+G_GNUC_INTERNAL
+void _rsvg_node_svg_apply_atts  (RsvgNodeSvg * self, RsvgHandle * ctx);
 
 G_END_DECLS
 
